diff --git a/client/tests/kvm/BEFORE_YOU_START b/client/tests/kvm/BEFORE_YOU_START
index 6b142fb..7478d9d 100644
--- a/client/tests/kvm/BEFORE_YOU_START
+++ b/client/tests/kvm/BEFORE_YOU_START
@@ -6,7 +6,7 @@ Copy kvm_tests.cfg.sample into kvm_tests.cfg
 Modify kvm_tests.cfg to your liking.
 Modify control if you prefer to "use your own kvm" (comment out kvm_install).
 
-Create those symbolic links under kvm_runtest_2 or under <rootdir>
+Create those symbolic links under kvm or under <rootdir>
 qemu                   -> qemu-kvm binary (unless using kvm_install)
 qemu-img               -> qemu-img binary (unless using kvm_install)
 isos/                  -> isos (mount or symlink)
diff --git a/client/tests/kvm/control b/client/tests/kvm/control
index 154d513..802f2aa 100644
--- a/client/tests/kvm/control
+++ b/client/tests/kvm/control
@@ -57,8 +57,8 @@ sys.path.append(pwd)
 # lines create those symlinks.
 # Change 'rootdir' here and/or mount appropriate directories in it
 # When dispatching tests on local host (client mode) one can
-# either setup kvm_runtest_2 links, or same as server mode
-# use rootdir and set all appropriate links/mount-points there.
+# either setup kvm links, or same as server mode use rootdir and set
+# all appropriate links/mount-points there.
 # For example, guest installation tests need to know where to
 # find the iso-files.
 # We create the links only if not already exist, so
diff --git a/client/tests/kvm/kvm_config.py b/client/tests/kvm/kvm_config.py
index 1595761..1ae5f10 100755
--- a/client/tests/kvm/kvm_config.py
+++ b/client/tests/kvm/kvm_config.py
@@ -25,7 +25,7 @@ class config:
         """
         Initialize the list and optionally parse filename.
 
-            @param filename: Path of the file that will be taken
+        @param filename: Path of the file that will be taken
         """
         self.list = [{"name": "", "shortname": "", "depend": []}]
         self.debug = debug
@@ -38,7 +38,7 @@ class config:
         """
         Enable or disable debugging output.
 
-            @param debug: Whether debug is enabled (True) or disabled (False).
+        @param debug: Whether debug is enabled (True) or disabled (False).
         """
         self.debug = debug
 
@@ -48,7 +48,7 @@ class config:
         Parse filename, return the resulting list and store it in .list. If
         filename does not exist, raise an exception.
 
-            @param filename: Path of the configuration file.
+        @param filename: Path of the configuration file.
         """
         if not os.path.exists(filename):
             raise IOError("File %s not found" % filename)
@@ -63,7 +63,7 @@ class config:
         """
         Parse a string, return the resulting list and store it in .list.
 
-            @param str: String that will be parsed.
+        @param str: String that will be parsed.
         """
         file = StringIO.StringIO(str)
         self.list = self.parse(file, self.list)
@@ -83,8 +83,8 @@ class config:
         """
         Return True if dict matches filter.
 
-            @param filter: A regular expression that defines the filter.
-            @param dict: Dictionary that will be inspected.
+        @param filter: A regular expression that defines the filter.
+        @param dict: Dictionary that will be inspected.
         """
         filter = re.compile("(\\.|^)" + filter + "(\\.|$)")
         return filter.search(dict["name"]) != None
@@ -94,8 +94,8 @@ class config:
         """
         Filter a list of dicts.
 
-            @param filter: A regular expression that will be used as a filter.
-            @param list: A list of dictionaries that will be filtered.
+        @param filter: A regular expression that will be used as a filter.
+        @param list: A list of dictionaries that will be filtered.
         """
         if list == None:
             list = self.list
@@ -111,9 +111,8 @@ class config:
         """
         Get the indexes of a list that match a given filter.
 
-            @param filter: A regular expression that will filter the list.
-            @param list: List which we want to know the indexes that match
-            a filter.
+        @param filter: A regular expression that will filter the list.
+        @param list: List which we want to know the indexes that match a filter.
         """
         if list == None:
             list = self.list
@@ -138,8 +137,8 @@ class config:
         """
         Split str and strip quotes from the resulting parts.
 
-            @param str: String that will be processed
-            @param sep: Separator that will be used to split the string
+        @param str: String that will be processed
+        @param sep: Separator that will be used to split the string
         """
         temp = str.split(sep, 1)
         for i in range(len(temp)):
@@ -152,8 +151,8 @@ class config:
         """
         Get the next non-empty, non-comment line in a file like object.
 
-            @param file: File like object
-            @return: If no line is available, return None.
+        @param file: File like object
+        @return: If no line is available, return None.
         """
         while True:
             line = file.readline()
diff --git a/client/tests/kvm/make_html_report.py b/client/tests/kvm/make_html_report.py
index 7fb54e5..2d3469f 100755
--- a/client/tests/kvm/make_html_report.py
+++ b/client/tests/kvm/make_html_report.py
@@ -1634,7 +1634,7 @@ def get_keyval_value(result_dir, key):
     Return the value of the first appearance of key in any keyval file in
     result_dir. If no appropriate line is found, return 'Unknown'.
     """
-    keyval_pattern = os.path.join(result_dir, "kvm_runtest_2.*", "keyval")
+    keyval_pattern = os.path.join(result_dir, "kvm.*", "keyval")
     keyval_lines = commands.getoutput(r"grep -h '\b%s\b.*=' %s"
                                       % (key, keyval_pattern))
     if not keyval_lines:
diff --git a/client/tests/kvm/scan_results.py b/client/tests/kvm/scan_results.py
index a92c867..14a3a7c 100755
--- a/client/tests/kvm/scan_results.py
+++ b/client/tests/kvm/scan_results.py
@@ -30,9 +30,9 @@ def parse_results(text):
             info = info_list.pop()
             test_name = parts[2]
             test_status = parts[0].split()[1]
-            # Remove 'kvm_runtest_2.' prefix
-            if test_name.startswith("kvm_runtest_2."):
-                test_name = test_name.split("kvm_runtest_2.")[1]
+            # Remove 'kvm.' prefix
+            if test_name.startswith("kvm."):
+                test_name = test_name.split("kvm.")[1]
             result_list.append((test_name, test_status, int(end_time - start_time), info))
 
         # Found a FAIL/ERROR/GOOD line -- get failure/success info