diff --git a/client/tests/kvm/steps/Win2000-32-rss.steps b/client/tests/kvm/steps/Win2000-32-rss.steps
new file mode 100644
index 0000000..34fa5f4
--- /dev/null
+++ b/client/tests/kvm/steps/Win2000-32-rss.steps
@@ -0,0 +1,52 @@
+# --------------------------------
+step 43.16
+screendump 20080101_000001_5b659c177604f5eefd34042a02463519.ppm
+# reached desktop; close "Getting Started" dialog
+barrier_2 86 12 120 58 deecf2363bbf8725264e9da8dd7a0c4e 216
+# Sending keys: alt-f4
+key alt-f4
+# --------------------------------
+step 45.98
+screendump 20080101_000002_e47965a8e2b13c234b2024caaf1cd8d2.ppm
+# open start menu
+barrier_2 83 62 283 219 34bb8f3f22754e871514abbc5a2d588a 14
+# Sending keys: ctrl-esc
+key ctrl-esc
+# --------------------------------
+step 47.91
+screendump 20080101_000003_b7fb19d51b89cb288639f2d528c6dd70.ppm
+# run...
+barrier_2 100 63 33 383 9f18731457b7d11c50ab92b81642c393 10
+# Sending keys: up up
+key up
+key up
+# --------------------------------
+step 49.98
+screendump 20080101_000004_e7a3f3fa3157129829c1526b0ad048e9.ppm
+barrier_2 43 19 63 389 32d9745c40deacbbed050934ecb22928 10
+# Sending keys: ret
+key ret
+# --------------------------------
+step 53.13
+screendump 20080101_000005_34cd11237ca61f9cf23dcacc4fd84826.ppm
+# run "d:\setuprss"
+barrier_2 53 75 254 306 9234a91426b8d28650cd6d2ddd60c0ff 16
+# Sending keys: d shift-0x27 0x2b s e t u p r s s ret
+key d
+key shift-0x27
+key 0x2b
+key s
+key e
+key t
+key u
+key p
+key r
+key s
+key s
+key ret
+# --------------------------------
+step unknown
+screendump 20080101_000014_e47965a8e2b13c234b2024caaf1cd8d2.ppm
+# make sure we're done
+sleep 20
+barrier_2 88 65 284 220 8ea5bd06fc592f91cdc322f4ed954469 120
diff --git a/client/tests/kvm/steps/Win2003-32-rss.steps b/client/tests/kvm/steps/Win2003-32-rss.steps
new file mode 100644
index 0000000..a194f6b
--- /dev/null
+++ b/client/tests/kvm/steps/Win2003-32-rss.steps
@@ -0,0 +1,49 @@
+# --------------------------------
+step 25.16
+screendump 20080101_000001_315f40a7863d9981afc999c525abd698.ppm
+barrier_2 48 13 425 231 4da32ca10d3191bc95eba6552c1e3d4d 180
+# Sending keys: ctrl-alt-delete
+key ctrl-alt-delete
+# --------------------------------
+step 27.98
+screendump 20080101_000002_9c888fc55dbcff4c54b2c8ca9abea561.ppm
+# login
+barrier_2 32 11 469 230 3b7b1974fe99ef2ceee9d49e2885253f 30
+# Sending keys: ret
+key ret
+# --------------------------------
+step 40.75
+screendump 20080101_000003_b29321f21ff99f7570213c9e53b2806a.ppm
+barrier_2 66 45 209 233 f8e61ca0d97b8af750fe7c3451401498 90
+# Sending keys: alt-f4
+key alt-f4
+# --------------------------------
+step 43.99
+screendump 20080101_000004_4e23508d4bf604e5939c9a715bde4e33.ppm
+# run command
+barrier_2 63 41 213 229 61e4e55ac2f0bc30a92d141363c1895a 16
+# Sending keys: 0xdc-r
+key 0xdc-r
+# --------------------------------
+step 49.52
+screendump 20080101_000006_f959391507e8a2eb9af10a802db56d7e.ppm
+# run "d:\setuprss"
+barrier_2 261 34 57 307 62d58248f633ce21c7330ab430e087eb 14
+# Sending keys: d shift-0x27 0x2b s e t u p r s s ret
+key d
+key shift-0x27
+key 0x2b
+key s
+key e
+key t
+key u
+key p
+key r
+key s
+key s
+key ret
+# --------------------------------
+step 88.35
+screendump 20080101_000015_dc5545b4db2a21f13918af699a9e1ffb.ppm
+# done
+barrier_2 62 41 208 229 0da402920a310728fb3cd78e4cbfc13a 90
diff --git a/client/tests/kvm/steps/Win2003-64-rss.steps b/client/tests/kvm/steps/Win2003-64-rss.steps
new file mode 100644
index 0000000..ad9247c
--- /dev/null
+++ b/client/tests/kvm/steps/Win2003-64-rss.steps
@@ -0,0 +1,47 @@
+# Generated by Step Maker
+# Generated on Sat Aug  8 22:59:51 2009
+# uname -a: Linux dhcp-1-188.tlv.redhat.com 2.6.18-128.1.1.el5 #1 SMP Mon Jan 26 13:58:24 EST 2009 x86_64 x86_64 x86_64 GNU/Linux
+# --------------------------------
+step 25.16
+screendump 20080101_000001_315f40a7863d9981afc999c525abd698.ppm
+barrier_2 48 13 425 231 4da32ca10d3191bc95eba6552c1e3d4d 180
+# Sending keys: ctrl-alt-delete
+key ctrl-alt-delete
+# --------------------------------
+step 27.98
+screendump 20080101_000002_9c888fc55dbcff4c54b2c8ca9abea561.ppm
+# login
+barrier_2 32 11 469 230 3b7b1974fe99ef2ceee9d49e2885253f 30
+# Sending keys: ret
+key ret
+# --------------------------------
+step 3.89
+screendump 20090808_225955_b71e538f693e411895d125b28764dbe3.ppm
+# reached desktop
+barrier_2 80 56 285 226 33ef5647b80b4cb24ea68221121a6cdb 180
+# Sending keys: 0xdc-r
+key 0xdc-r
+# --------------------------------
+step 15.63
+screendump 20090808_230251_bb4e1f7922b0f4c7dd1ba08633fd2740.ppm
+# run "d:\setuprss"
+barrier_2 263 34 56 306 cd45be08381106e04309bd65f2538571 25
+# Sending keys: d shift-0x27 0x2b s e t u p r s s ret
+key d
+key shift-0x27
+key 0x2b
+key s
+key e
+key t
+key u
+key p
+key r
+key s
+key s
+key ret
+# --------------------------------
+step 3.89
+screendump 20090808_225955_b71e538f693e411895d125b28764dbe3.ppm
+# make sure we're done
+sleep 20
+barrier_2 80 56 285 226 33ef5647b80b4cb24ea68221121a6cdb 90
diff --git a/client/tests/kvm/steps/Win2008-32-rss.steps b/client/tests/kvm/steps/Win2008-32-rss.steps
new file mode 100644
index 0000000..0194dad
--- /dev/null
+++ b/client/tests/kvm/steps/Win2008-32-rss.steps
@@ -0,0 +1,49 @@
+# --------------------------------
+step 40.51
+screendump 20080101_000001_7a0db57f6d01f839e830c034906e18ba.ppm
+barrier_2 470 64 167 217 6315f1c924edab4bff73403959131051 203
+# Sending keys: ctrl-alt-delete
+key ctrl-alt-delete
+# --------------------------------
+step 44.89
+screendump 20080101_000002_b48665cc639417d1c0534b06eff5afdb.ppm
+barrier_2 50 16 296 393 cebca0ab4704c6f674987b582e400c5f 22
+# Sending keys: 1 q 2 w 3 e shift-p ret
+key 1
+key q
+key 2
+key w
+key 3
+key e
+key shift-p
+key ret
+# --------------------------------
+step unknown
+screendump 20080101_000003_50cdcf315b19d33afb9db50d372cceb6.ppm
+barrier_2 46 45 375 290 b31d69288fc8d8b7661cfe5d5c93c117 292
+# Sending keys: 0xdc-r
+key 0xdc-r
+# --------------------------------
+step 132.34
+screendump 20080101_000010_fbb85586d6ae0a031d6eea173e3fd940.ppm
+# run "d:\setuprss"
+barrier_2 35 60 268 387 ba4f5d1fd4282cac4f6bb93b8adb2911 12
+# Sending keys: d shift-0x27 0x2b s e t u p r s s ret
+key d
+key shift-0x27
+key 0x2b
+key s
+key e
+key t
+key u
+key p
+key r
+key s
+key s
+key ret
+# --------------------------------
+step 175.40
+screendump 20080101_000003_50cdcf315b19d33afb9db50d372cceb6.ppm
+# all done!
+sleep 20
+barrier_2 53 48 369 289 17a327dc76e1e0b26a69350bbe31f2d6 90
diff --git a/client/tests/kvm/steps/Win2008-64-rss.steps b/client/tests/kvm/steps/Win2008-64-rss.steps
new file mode 100644
index 0000000..0a72885
--- /dev/null
+++ b/client/tests/kvm/steps/Win2008-64-rss.steps
@@ -0,0 +1,52 @@
+# --------------------------------
+step 40.51
+screendump 20080101_000001_7a0db57f6d01f839e830c034906e18ba.ppm
+# (screendump taken from Win2008.32)
+barrier_2 61 56 379 287 40a28652310261533c6018439c58fb15 203
+# Sending keys: ctrl-alt-delete
+key ctrl-alt-delete
+# --------------------------------
+step 44.89
+screendump 20080101_000002_b48665cc639417d1c0534b06eff5afdb.ppm
+# (screendump taken from Win2008.32)
+barrier_2 44 33 418 385 c68f71048c2fc84e82ed7fa84abe62a3 22
+# Sending keys: 1 q 2 w 3 e shift-p ret
+key 1
+key q
+key 2
+key w
+key 3
+key e
+key shift-p
+key ret
+# --------------------------------
+step unknown
+screendump 20080101_000003_50cdcf315b19d33afb9db50d372cceb6.ppm
+# (screendump taken from Win2008.32)
+barrier_2 46 45 375 290 b31d69288fc8d8b7661cfe5d5c93c117 292
+# Sending keys: 0xdc-r
+key 0xdc-r
+# --------------------------------
+step 132.34
+screendump 20080101_000010_fbb85586d6ae0a031d6eea173e3fd940.ppm
+# run "d:\setuprss" (screendump taken from Win2008.32)
+barrier_2 37 34 313 431 1a110a076ce7a418294c007fa9070eee 12
+# Sending keys: d shift-0x27 0x2b s e t u p r s s ret
+key d
+key shift-0x27
+key 0x2b
+key s
+key e
+key t
+key u
+key p
+key r
+key s
+key s
+key ret
+# --------------------------------
+step 175.40
+screendump 20080101_000003_50cdcf315b19d33afb9db50d372cceb6.ppm
+# all done! (screendump taken from Win2008.32)
+sleep 20
+barrier_2 53 48 369 289 17a327dc76e1e0b26a69350bbe31f2d6 90
diff --git a/client/tests/kvm/steps/Win2008-64.steps b/client/tests/kvm/steps/Win2008-64.steps
index 932b873..e9e23be 100644
--- a/client/tests/kvm/steps/Win2008-64.steps
+++ b/client/tests/kvm/steps/Win2008-64.steps
@@ -73,5 +73,33 @@ key ret
 # --------------------------------
 step 1732.47
 screendump 20080101_000011_b8ee0f8e288f7dd443605e0cf5d91c61.ppm
-# Win2008 Finish
+# Desktop reached
 barrier_2 49 16 2 579 5bfe5b0a9fa7648373e9ad84d3119a5d 232
+# Sending keys: 0xdc-r
+key 0xdc-r
+# --------------------------------
+step 1732.47
+screendump 20090809_051015_fbb85586d6ae0a031d6eea173e3fd940.ppm
+# Shutdown (screendump taken from Win2008.32)
+barrier_2 38 35 312 430 684748292c757ae5eb7bf4299df70171 10
+# Sending keys: s h u t d o w n spc slash s spc slash f spc slash t spc 0 ret
+key s
+key h
+key u
+key t
+key d
+key o
+key w
+key n
+key spc
+key slash
+key s
+key spc
+key slash
+key f
+key spc
+key slash
+key t
+key spc
+key 0
+key ret
diff --git a/client/tests/kvm/steps/WinVista-32-rss.steps b/client/tests/kvm/steps/WinVista-32-rss.steps
new file mode 100644
index 0000000..643f52e
--- /dev/null
+++ b/client/tests/kvm/steps/WinVista-32-rss.steps
@@ -0,0 +1,54 @@
+# Generated by Step Maker
+# Generated on Sun Aug  9 04:19:57 2009
+# uname -a: Linux dhcp-1-188.tlv.redhat.com 2.6.18-128.1.1.el5 #1 SMP Mon Jan 26 13:58:24 EST 2009 x86_64 x86_64 x86_64 GNU/Linux
+# --------------------------------
+step 71.65
+screendump 20090809_042109_8c9fa395fde6d45736fe5e78ebad061e.ppm
+# reached desktop; open start menu
+barrier_2 78 30 358 234 d864236c59edceb198409f034b61aa0e 358
+# Sending keys: ctrl-esc
+key ctrl-esc
+# --------------------------------
+step 76.05
+screendump 20090809_042139_c3155a2c89fcd79dc61478af560ed357.ppm
+# run "d:\setuprss"
+barrier_2 50 13 28 545 42dcbd7b221f12845583f08fb6dbbc66 21
+# Sending keys: d shift-0x27 0x2b s e t u p r s s
+key d
+key shift-0x27
+key 0x2b
+key s
+key e
+key t
+key u
+key p
+key r
+key s
+key s
+# --------------------------------
+step 83.19
+screendump 20090809_042249_46f97eb05a2aabfc918fed642038c03a.ppm
+barrier_2 18 25 14 12 0f48ac3d9a2c1d88d0519721129ce8bf 23
+# Sending keys: down menu
+key down
+key menu
+# --------------------------------
+step 88.52
+screendump 20090809_042324_0eac577fff261097eb35e8a3e41b11ba.ppm
+# run as administrator
+barrier_2 21 58 128 138 9d6d14c39767166f2dd54b644b4430a3 24
+# Sending keys: a
+key a
+# --------------------------------
+step 93.15
+screendump 20090809_042342_0abaf4bb1d04389c5b4548dc031989ca.ppm
+# continue
+barrier_2 20 44 248 239 522013a7f99ea1a1dfbb4a4d5c61dd2a 90
+# Sending keys: alt-c
+key alt-c
+# --------------------------------
+step 102.84
+screendump 20090809_042403_e287c85ba9d66dd09412917bfc1fecb5.ppm
+# make sure we're done
+sleep 20
+barrier_2 87 25 353 387 4335934bbb63865c37aa2aa6c2376440 90
diff --git a/client/tests/kvm/steps/WinVista-64-rss.steps b/client/tests/kvm/steps/WinVista-64-rss.steps
new file mode 100644
index 0000000..611a420
--- /dev/null
+++ b/client/tests/kvm/steps/WinVista-64-rss.steps
@@ -0,0 +1,54 @@
+# Generated by Step Maker
+# Generated on Sun Aug  9 03:27:16 2009
+# uname -a: Linux dhcp-1-188.tlv.redhat.com 2.6.18-128.1.1.el5 #1 SMP Mon Jan 26 13:58:24 EST 2009 x86_64 x86_64 x86_64 GNU/Linux
+# --------------------------------
+step 78.22
+screendump 20090809_032834_6adc21f17f854751b7c5ef6814afe4be.ppm
+# reached desktop; open start menu
+barrier_2 109 32 319 245 e40688e5ea8acae0068bf32ae0882d66 391
+# Sending keys: ctrl-esc
+key ctrl-esc
+# --------------------------------
+step 83.61
+screendump 20090809_033130_129378458c3edb1ef199ba8dbb6450fa.ppm
+# run "d:\setuprss"
+barrier_2 56 16 26 543 92e2726e7aa3de5bda7cb0448729e569 26
+# Sending keys: d shift-0x27 0x2b s e t u p r s s
+key d
+key shift-0x27
+key 0x2b
+key s
+key e
+key t
+key u
+key p
+key r
+key s
+key s
+# --------------------------------
+step 90.03
+screendump 20090809_033308_427a6436d2d53bc48a550d6e9d51ea30.ppm
+barrier_2 17 23 14 12 1ee0bb3e04af4ae9cad6ea4d7e60ee0c 20
+# Sending keys: down menu
+key down
+key menu
+# --------------------------------
+step 93.51
+screendump 20090809_033402_35adbe6265a33ea3e710bc6c345ddeb4.ppm
+# run as administrator
+barrier_2 24 63 128 138 f1048184cda8600c51d6b4c8c272d60f 15
+# Sending keys: a
+key a
+# --------------------------------
+step 99.21
+screendump 20090809_033431_30cfd66164171798c723f1ebd9d2dd63.ppm
+# continue
+barrier_2 30 45 240 239 a99732ded3422fa552a5eebd19104bf1 90
+# Sending keys: alt-c
+key alt-c
+# --------------------------------
+step 110.47
+screendump 20090809_033505_56d081cf5ec82e94c86341cfe782f982.ppm
+# done
+sleep 20
+barrier_2 102 30 328 387 989a51cb302891c8a0a1ff5cc9a528be 90
diff --git a/client/tests/kvm/steps/WinXP-32-rss.steps b/client/tests/kvm/steps/WinXP-32-rss.steps
new file mode 100644
index 0000000..8adc8f5
--- /dev/null
+++ b/client/tests/kvm/steps/WinXP-32-rss.steps
@@ -0,0 +1,31 @@
+# --------------------------------
+step 24.72
+screendump 20080101_000001_5965948293222a6d6f3e545db40c23c1.ppm
+# desktop reached -- run command
+barrier_2 47 49 392 292 09453beafc5f60b6dcb9af1b27339ca1 124
+# Sending keys: 0xdc-r
+key 0xdc-r
+# --------------------------------
+step 29.87
+screendump 20080101_000003_3978b6f6e3cd2d7c4c4caaf6e1e35330.ppm
+# run "d:\setuprss"
+barrier_2 43 103 266 426 c5dc4e4ac4c50a90f35399cc126232ed 30
+# Sending keys: d shift-0x27 0x2b s e t u p r s s ret
+key d
+key shift-0x27
+key 0x2b
+key s
+key e
+key t
+key u
+key p
+key r
+key s
+key s
+key ret
+# --------------------------------
+step 64.82
+screendump 20080101_000012_eccf0a634b6fc479327cf9cc165da7ae.ppm
+# done
+sleep 20
+barrier_2 92 133 395 244 ccda184de1b1d68eb091e2950792cb2f 90
diff --git a/client/tests/kvm/steps/WinXP-64-rss.steps b/client/tests/kvm/steps/WinXP-64-rss.steps
new file mode 100644
index 0000000..a47c19c
--- /dev/null
+++ b/client/tests/kvm/steps/WinXP-64-rss.steps
@@ -0,0 +1,34 @@
+# Generated by Step Maker
+# Generated on Sat Aug  8 22:08:14 2009
+# uname -a: Linux dhcp-1-188.tlv.redhat.com 2.6.18-128.1.1.el5 #1 SMP Mon Jan 26 13:58:24 EST 2009 x86_64 x86_64 x86_64 GNU/Linux
+# --------------------------------
+step 45.95
+screendump 20090808_220900_04a6bdc48c7e7b21c40da156b3c5e39a.ppm
+# desktop reached
+barrier_2 68 20 10 455 84c2097166d61662c0da0f522ba6a860 230
+# Sending keys: 0xdc-r
+key 0xdc-r
+# --------------------------------
+step 53.61
+screendump 20090808_221018_06c2ba8c6966a365906b77617c83d476.ppm
+# run "d:\setuprss"
+barrier_2 16 93 212 323 64761f230c3f6e00edb6b063aed94a4d 37
+# Sending keys: d shift-0x27 0x2b s e t u p r s s ret
+key d
+key shift-0x27
+key 0x2b
+key s
+key e
+key t
+key u
+key p
+key r
+key s
+key s
+key ret
+# --------------------------------
+step 69.47
+screendump 20090808_221132_2cd6b5b84c57818069a39edcd6598670.ppm
+# done
+sleep 20
+barrier_2 60 48 298 227 a69789a0554529572d8b721dc0a6bf9a 69